//+------------------------------------------------------------------+
//|                                          ME_CorrelationIndex.mq4 |
//|                                                          pronych |
//+------------------------------------------------------------------+
#include <stdlib.mqh>
#property copyright "pronych"
#property  indicator_separate_window
#property  indicator_buffers 5
#property indicator_color1 Aquamarine
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Yellow
#property indicator_color5 Aqua
#property indicator_width1           1
#property indicator_width2           1
#property indicator_width3           2
#property indicator_width4           2
#property indicator_width5           2
#define FilePrefix                  "ME_"    //  
#define TotalIndexListFileName      "ME_indexes_list.set"    //       
#define TotalCurrencyListFileName   "ME_currency_list.set" //      
#define CorrListFilePreName         "ME_CorrList_" //      

#define LAST_UPPER                  +1
#define LAST_NONE                    0
#define LAST_LOWER                  -1
//---- indicator buffers
extern int    CountBars             =1200;
//extern int      TFIndex       =7;//   ,       (     )
//extern int      StartBar      =2;// ,       -     

string Symbols;
int    SymbolsCnt=0;
double SymIndex[];
double CorrIndex[];
double BBH[];
double BBL[];
double Signal[];

double ItemIndex[];
string SymbolsOf[];
int SymbolsSignOf[];
int CurrCnt;

double LastValue;//   (Signal).   ApproximateProfit
double ApproximateProfit;//   ,   

//int TFNum[10]={0,PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};//     
double TickSize;
double MaxValue=0;
//datetime RefreshEveryOf[10];
string SymbolsFile        ="";
string Sym,SymPartL,SymPartR;
int MarketType;
bool FirstStart=true;
double StartPriceSym;
datetime StartBarTime;
int      LastPosition=0;
//#include <me_visualisation_v1.mq4>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
LastPosition=0;ApproximateProfit=0;LastValue=0;// 
//---- additional buffers are used for counting
int handle;Sym=Symbol();SymPartL=StringSubstr(Sym,0,3);SymPartR=StringSubstr(Sym,3);
MarketType=MarketInfo(Sym,MODE_PROFITCALCMODE);
TickSize=MarketInfo(Sym,MODE_TICKSIZE);
SymbolsFile=CorrListFilePreName+Sym+".set";
SymbolsCnt=ReadCSV(SymbolsFile,SymbolsOf,Sym);//    
  if(SymbolsCnt<0)//   
  {//   'Total_currency.set'  Total_index.set   
    Print("! "+CorrListFilePreName+Sym+".set  "+SymbolsFile+"  !");
    IndicatorShortName(SymbolsFile+"  !");
    string sStr;
    //----------------------    -------------------------------
    //       ,     
    Print("      "+CorrListFilePreName+"help.txt");
    sStr=     "    ME_CorrelationIndex,   ";
    sStr=sStr+" c "+Sym+" ,      ";
    sStr=sStr+ CorrListFilePreName+Sym+".set.      .";
    sStr=sStr+"          "+TotalIndexListFileName +"  ,  "+ TotalCurrencyListFileName +"   .";
    sStr=sStr+" ,   ,         .";
    sStr=sStr+"        .    ";
    sStr=sStr+"        .   ,    .";
    handle=FileOpen(CorrListFilePreName+"help.txt",FILE_CSV|FILE_WRITE);
    if(handle!=-1){FileWrite(handle,sStr);FileClose(handle);}
    //----------------------    -------------------------------
  //   
    if(MarketType==0)SymbolsFile=TotalCurrencyListFileName;//   ( 
    else SymbolsFile=TotalIndexListFileName;// ())
   
   SymbolsCnt=ReadCSV(SymbolsFile,SymbolsOf,Sym);// ,   
    if(SymbolsCnt==-1)//      
    {//       ,     
    //----------------------     ( ) -------------------------------
      if(MarketType==0)// 
      {// ,    
      sStr     ="AUDUSD,EURUSD,GBPCHF,GBPJPY,GBPUSD,USDCAD,USDCHF,USDJPY,USDRUB,USDZAR,AUDNOK,";
      sStr=sStr+"USDUAH,USDSGD,USDSEK,USDNOK,USDHKD,USDDKK,NZDUSD,AUDCAD,AUDCHF,AUDDKK,AUDEUR,";
      sStr=sStr+"AUDJPY,EURGBP,AUDNZD,AUDSEK,AUDSGD,CADCHF,CADJPY,CHFJPY,CHFNOK,CHFSGD,EURAUD,";
      sStr=sStr+"EURCAD,EURCHF,GBPSEK,EURHKD,EURJPY,EURNOK,EURNZD,EURSEK,EURSGD,GBPAUD,GBPCAD,";
      sStr=sStr+"GBPDKK,GBPNOK,GBPNZD,GBPSGD,NOKJPY,NZDCAD,NZDCHF,NZDGBP,NZDJPY,NZDSGD,SEKJPY,SGDJPY,USDSKK";
      }else//  ,    
      {sStr="";}
      SymbolsCnt=StringDisassemble(SymbolsOf,sStr,",");
      WriteCSV(SymbolsFile,SymbolsOf);
    sStr="";
    //----------------------     ( ) -------------------------------
   SymbolsCnt=ReadCSV(SymbolsFile,SymbolsOf,Sym);//  (   )   
    }
   //------       ( ) ---------------
   SymbolsFile=CorrListFilePreName+Sym+".set";
    if(MarketType==0 && StringLen(Sym)==6)//       (6 )
    {//  ,     
     SymbolsCnt=SymbolsFilter(SymbolsOf,SymPartL,SymPartR);//
    }
     SymbolsSignReplace(SymbolsOf,SymbolsSignOf);//    
     SymbolsSignPlace(SymbolsOf,SymbolsSignOf);//          
     if(SymbolsCnt>0)WriteCSV(SymbolsFile,SymbolsOf);//    
   //----------      ( ) -------------------
   }
     SymbolsSignReplace(SymbolsOf,SymbolsSignOf);//      
   IndicatorBuffers(8);
//---- indicator buffers mapping
   SetIndexBuffer(0, SymIndex);
   SetIndexBuffer(1, CorrIndex);
   SetIndexBuffer(2, BBH);
   SetIndexBuffer(3, BBL);
   SetIndexBuffer(4, Signal);

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);
   SetIndexEmptyValue(3,0.0);
   SetIndexEmptyValue(4,0.0);
//---- drawing settings
SetIndexStyle(0,DRAW_HISTOGRAM);
SetIndexStyle(1,DRAW_HISTOGRAM);
SetIndexStyle(2,DRAW_LINE);
SetIndexStyle(3,DRAW_LINE);
SetIndexStyle(4,DRAW_SECTION);
//SetIndexArrow(4,108) ;
//
//---- name for DataWindow and indicator subwindow label
string tmp="";
for (int f=0;f<SymbolsCnt;f++)
{
if(SymbolsSignOf[f]>0){tmp=tmp+"+";}else{tmp=tmp+"-";}
tmp=tmp+ SymbolsOf[f]+" ";
}
ArrayResize(ItemIndex,SymbolsCnt);//         

if (tmp=="")tmp="NO SYMBOLS!!!";
//SetLevelValue(0,MaxTFIndex*SymbolsCnt);
//SetLevelStyle( STYLE_DASH,1,Yellow);
if( StringLen(tmp)>50)tmp="Symbols total: "+ SymbolsCnt;
   IndicatorShortName("ME_CF "+SymbolsCnt+" ( " +tmp+ ")");
//---- initialization done
   SetIndexLabel(0,"Index of "+SymbolsCnt+" other symbols" );
   SetIndexLabel(1,"Index of "+Sym);
   SetIndexLabel(2,"BBH");
   SetIndexLabel(3,"BBL");
   SetIndexLabel(4,"Signal");
   return(0);
  }
//+----------------------------------------------start()--------------------------------------------+
int start()
{
if(SymbolsCnt<=0)return;//
   string CurSym="";
   int    limit;
   int    counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//----

    for(int i=0; i<=limit; i++)
    {
     int CurSIndex=0;double CIndex=0;double ItemCurValue=0;
      datetime BarTime=iTime(Sym,0,i);//     
    //-------------------------       -------------------------
      CurSym=SymbolsOf[0];// 
      double CurValue=iClose(Sym,0,i);//    
      
      
      int ItemBar=iBarShift(CurSym,0,BarTime,true);//    ,   ,  -1
      
      if(ItemBar>-1) //        
         {
         ItemCurValue=iClose(CurSym,0,ItemBar);//   
         SymIndex[i]=(CurValue-ItemCurValue)/TickSize;//    
         CorrIndex[i]=0.0;//  
         }
      else           //        
         {
         ItemCurValue=iClose(CurSym,0,iBarShift(CurSym,0,BarTime,false));//  ,   
         CorrIndex[i]=(CurValue-ItemCurValue)/TickSize;//     
         SymIndex[i]=CorrIndex[i];//  
         }
      
    
    }
    for( i=limit; i>=0; i--)
    {
    BBH[i]=iBandsOnArray(SymIndex,0,30,2,0,MODE_UPPER,i);
    BBL[i]=iBandsOnArray(SymIndex,0,30,2,0,MODE_LOWER,i);
    //Signal[i]=3+iBandsOnArray(SymIndex,0,30,2,0,MODE_LOWER,i);
    //Sig[i]=BBH[i]+5;
      if(CorrIndex[i]==0)// ,     (  ) 
      {
         if(LastPosition<LAST_UPPER && SymIndex[i]>BBH[i])  //     ,  
         {//     
         Signal[i]=BBH[i];                                  //     ( )
         ApproximateProfit=+(Signal[i]-LastValue);          //     
         LastValue=Signal[i];                               //    
         LastPosition=LAST_UPPER;                           //,     -
         Comment(ApproximateProfit);
         }
                                                            //
         if(LastPosition>LAST_LOWER && SymIndex[i]<BBL[i])  //     ,  
         {//     
         Signal[i]=BBL[i];                                  //     ( )
         ApproximateProfit=+(LastValue-Signal[i]);          //     
         LastValue=Signal[i];                               //    
         LastPosition=LAST_LOWER;                           //,     -
         Comment(ApproximateProfit);
         }
      }
    
    }
//CalculateStatistic(0);//   .      (0= ,    )
 //---- done
FirstStart=false;
return(0);
}
//+------------------------------------------------------------------+
void CalculateStatistic(int TFIndex)//    
{
   if(TFIndex==0)
   {
   
   }


}
//+------------------------------------------------------------------+
int StringDisassemble(string &ArrOf[],string Str,string Delimiter=";",bool Trim=true)
{//   
int DelimiterPos=-1,DelimiterPrev=0;int strlen=StringLen(Str);int ArrIndex=0;//string tmp="";
ArrayResize(ArrOf,0);
   while (true)
   {
   DelimiterPos=StringFind(Str,Delimiter,DelimiterPos+1);
   ArrayResize(ArrOf,ArrIndex+1);
   ArrOf[ArrIndex]=StringSubstr(Str, DelimiterPrev, DelimiterPos-DelimiterPrev) ;
   if(DelimiterPos==-1)break;
   ArrIndex++;DelimiterPrev=DelimiterPos+1;
   }
ArrOf[ArrIndex]=StringSubstr(Str, DelimiterPrev);
if(ArrOf[ArrIndex]!="")ArrIndex++;
if(Trim){for (DelimiterPos=0;DelimiterPos<ArrIndex;DelimiterPos++)ArrOf[DelimiterPos]=StringTrimRight(StringTrimLeft(ArrOf[DelimiterPos]));}
//for (DelimiterPos=0;DelimiterPos<ArrIndex;DelimiterPos++)tmp=tmp+ArrOf[DelimiterPos];
//Comment(Str + "\n" + tmp + "\n" + DelimiterPrev  + "\n" + (strlen));
return(ArrIndex);
}
/////////////////////////////  ReadCSV  /////////////////////////////
int ReadCSV(string FName,string &ArrOf[],string Except="",string Delimiter=";",bool Trim=true)
{//    .    ,  -1
int ICnt=0;string Item="";ArrayResize(ArrOf,ICnt);
int handle=FileOpen(FName,FILE_CSV|FILE_READ,Delimiter);
  if(handle<0)return(-1);//   
   while (!FileIsEnding(handle))
   {
   Item=FileReadString(handle);
   if(Trim)Item=StringTrimLeft(StringTrimRight(Item));
   if(Except!=""){if(StringFind(Item,Except)>-1)continue;}
   if(Item=="")continue;
   ICnt++;ArrayResize(ArrOf,ICnt);ArrOf[ICnt-1]=Item;
   if(FileIsEnding(handle))break;
   }
   FileClose(handle);
return(ICnt);
}
/////////////////////////////  WriteCSV  /////////////////////////////
int WriteCSV(string FName,string &ArrOf[])
{
int i=ArraySize(ArrOf);
int handle=FileOpen(FName,FILE_CSV|FILE_WRITE,';');
    for(int f=0; f<i;f++)FileWrite(handle,ArrOf[f]);
    if(handle!=-1)FileClose(handle);
return(i);
}
///////////////////////////  SymbolsFilter  ///////////////////////////
int SymbolsFilter(string &ArrOf[],string fltStr1,string fltStr2="")
{//
int i=ArraySize(ArrOf);int f;int sSet=0;
   for(f=0;f<i;f++)//     :)
   {// .  ,     
    if(StringFind(ArrOf[f],fltStr1)>-1)continue;   //   ,   
    else{                                          //  
    if(fltStr2==""){ArrOf[f]="";continue;}//   ,   
    if(StringFind(ArrOf[f],fltStr2)==-1){ArrOf[f]="";}//     ,   
        }// .   ,     
   }//      
   for(f=0;f<i;f++)//      
   {//    
   if(ArrOf[f]!=""){ArrOf[sSet]=ArrOf[f];sSet++;}//          
   }
ArrayResize(ArrOf,sSet);
return(sSet);
}
///////////////////////////  SymbolsSignReplace  ///////////////////////////
int SymbolsSignReplace(string &ArrOf[],int &ArrSgnOf[])//   SymbolsSignPlace
{//     ArrOf    -,  ArrSgnOf=-1    
int f;string CharSign="";
int i=ArraySize(ArrOf);//  
ArrayResize(ArrSgnOf,i);//     ,   
   for(f=0;f<i;f++)// 
   {
   CharSign=StringSubstr(ArrOf[f],0,1);//      
   if(CharSign=="-"){ArrSgnOf[f]=-1;ArrOf[f]=StringSubstr(ArrOf[f],1);continue;}//  '-',   
   if(CharSign=="+"){ArrSgnOf[f]=+1;ArrOf[f]=StringSubstr(ArrOf[f],1);continue;}//  '+',  
   //     ,    (      )
    ArrSgnOf[f]=+1;//   '+',   ,    
    if(MarketType==0 && StringLen(Sym)==6)//       (6 )
    {//    
    if(SymPartL==StringSubstr(ArrOf[f],3,0))ArrSgnOf[f]=-1;//       ,  -1
    if(SymPartR==StringSubstr(ArrOf[f],0,3))ArrSgnOf[f]=-1;//        ,  -1
    }//    ,   .   ,   "+"
   }
return(1);
}
///////////////////////////  SymbolsSignPlace  ///////////////////////////
int SymbolsSignPlace(string &ArrOf[],int &ArrSgnOf[])//   SymbolsSignReplace
{// +1  -1  ArrSgnOf    ArrOf,   +  - (0   )
int f;string CharSign="";
int i=ArraySize(ArrOf);//  
   for(f=0;f<i;f++)// 
   {//         
   if(ArrSgnOf[f]==-1)ArrOf[f]=StringConcatenate("-",ArrOf[f]);// ,  
   else               ArrOf[f]=StringConcatenate("+",ArrOf[f]);//   
   }
return(1);
}
/////////////////////////////////////// PercentGain /////////////////////////////////////////////
double PercentGain(double Before, double After)
{//  
if(Before*(After-Before)==0)return(0.0);
return(100/Before*(After-Before));
}

